#include <iostream>
#include <cmath>

using namespace std;

int main()
{
    int t;
    cin >> t;
    int r[t];
    for(int k = 0; k < t; k++)
    {
        int n, m, rez = 1, imin;
        cin >> n >> m;
        long long a[n], b[m];
        for(int i = 0; i < n; i++)
            cin >> a[i];
        for(int i = 0; i < 2; i++)
        {
            imin = i;
            for(int j = i+1; j < n; j++)
                if(a[j] < a[imin])
                    imin = j;
            swap(a[i], a[imin]);
        }
        long long brmin = a[1] - a[0];
        for(int i = 0; i < m; i++)
            cin >> b[i];
        for(int i = 2; i < n && rez; i++)
            if((a[i] - a[0]) % brmin != 0)
                rez = 0;
        for(int i = 0; i < m && rez; i++)
            if((b[i] - a[0]) % brmin == 0)
                rez = 0;
        r[k] = rez;
    }
    for(int &x : r) cout << x << endl;
    return 0;
}